( function () {

	angular.module('eTakeAway', ['ionic', 'controllers', 'services', 'ngCordova','ngMaterial','ionic.rating','validation.match','ngMap','ngSanitize'])
	.run( function ($ionicPlatform, $rootScope, $state, eTakeAwayService,$ionicPopup,$cordovaSplashscreen) {
		$ionicPlatform.ready(function() {

      $rootScope.debug = false;

			if (window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				cordova.plugins.Keyboard.disableScroll(true);
			}

			if (window.StatusBar) {
				StatusBar.styleDefault();
			}

			$rootScope.customer_id = localStorage.getItem('customer_id');
			if ($rootScope.customer_id) {
				eTakeAwayService.cartDetails({customer_id: $rootScope.customer_id});
			}
			else {
				$rootScope.cartSize = 0;
				$rootScope.cartTotal = '£0.00';
			}

      if(window.cordova) {
        $cordovaSplashscreen.hide();
      }
      $ionicPlatform.registerBackButtonAction(function (event) {
        if($state.current.name == "app.main")
        {
          var confirmPopup = $ionicPopup.confirm({
            title: 'Confirmation',
            template: 'Are you sure you want to exit?',
            okType:'button-assertive'
          });

          confirmPopup.then(function(res) {
            if(res) {
              navigator.app.exitApp();
            } else {
              event.preventDefault();
              event.stopPropagation();
            }
          });
        }
        else {
          event.preventDefault();
          event.stopPropagation();
        }
      }, 100);

		});
	})

	.config(function($mdThemingProvider,$ionicConfigProvider) {
		$ionicConfigProvider.views.swipeBackEnabled(false);
		//I will be extending this pallete as I play around wiht custom themes
		$mdThemingProvider.definePalette('white', {
			'50' :  'ffffff',
			'100': '616161', //this is the default color of text on inactive tabs
			'200': '000000',
			'300': '000000',
			'400': '000000',
			'500': '000000',
			'600': '000000',
			'700': '000000',
			'800': '000000',
			'900': '000000',
			'A100': '000000',
			'A200': 'ffffff', //this is the default background color of tabs
			'A400': '000000',
			'A700': '000000',
			'contrastDefaultColor': 'dark'    // whether, by default, text (contrast)
			// on this palette should be dark or light
//            'contrastDarkColors': ['50', '100', //hues which contrast should be 'dark' by default
//                '200', '300', '400', 'A100','500'],
//            'contrastLightColors': undefined    // could also specify this if default was 'dark'
		});




		var yellowish = $mdThemingProvider.extendPalette('amber', {
			'contrastDefaultColor': 'light'
		});

		$mdThemingProvider.definePalette('yellowish', yellowish);
		$mdThemingProvider.theme('default')
		.primaryPalette('yellowish')
		.accentPalette('white');
	})

}());
