( function () {

  angular.module('controllers', [])

    .controller('AppCtrl', function ($scope, $state) {

    })

    .controller('LoadingCtrl', function ($scope, $state, $rootScope, dbService) {
      $scope.progress = 0;

      dbService.prepareDatabase()
        .then(function (menu) {
          $state.go('app.main');
        }, function (err) {
          console.log(err);
        }, function (progress) {
          $scope.progress = progress;
        });
    })

    .controller('MainCtrl', function ($scope,$ionicPopup, $templateCache, $ionicSlideBoxDelegate, $ionicLoading, $state, $rootScope, eTakeAwayService, offers, storeStatus, storeInfo) {

      $ionicLoading.hide();
     // console.log('customer_id =', localStorage.getItem('customer_id'));
      $scope.offers = offers.offers;

      var weekday = new Array(7);
      weekday[0] = "sunday";
      weekday[1] = "monday";
      weekday[2] = "tuesday";
      weekday[3] = "wednesday";
      weekday[4] = "thursday";
      weekday[5] = "friday";
      weekday[6] = "saturday";
      var today = new Date();
      today = weekday[today.getDay()];
       
      $scope.todaytimes = storeInfo.store_times[today];

      if (storeStatus.storeopened != 0) {
        $scope.image = "img/open.png";
        $scope.storeOpened = true;
      }
      else if (storeStatus.storeopened == 0) {
        $scope.storeOpened = false;
        $scope.image = "img/open.png";
      }

      $scope.gotoFeedback = function () {
        if ($rootScope.customer_id) {
          $state.go('app.feedback');
        }
        else {
          $state.go('app.welcome', {referrer: 'feedback'});
        }
      };

      $scope.showAlert = function(imgSource,title,text) {
        var alertPopup = $ionicPopup.alert({
          title: title,
          template: '<img src="' +imgSource + '" style="width:100%;" ng-if="'+imgSource.length+'">' +
                    '<p>'+text+'</p>'
        });
      }

        $scope.gotoMyAccount = function () {
        if ($rootScope.customer_id) {
          $state.go('app.accountDetail');
        }
        else {
          $state.go('app.welcome', {referrer: 'account'});
        }
      }

      $scope.slideNext = function () {
        $ionicSlideBoxDelegate.next();
      };

      $scope.slidePrevious = function () {
        $ionicSlideBoxDelegate.previous();
      };

    })

    .controller('LoginCtrl', function ($scope, $state, $stateParams, $rootScope, eTakeAwayService) {
      $scope.msg = "";
      $scope.alert = false;
      $scope.user = {};

      $scope.doLogin = function () {
          console.log("LOGIN");
        eTakeAwayService.login($scope.user).then(function (res) {
          if (res.error) {
            $scope.alert = true;
            $scope.msg = res.error;
          }
          else {
            localStorage.setItem('customer_id', res.success.customer_id);
            localStorage.setItem('address_id', res.success.address_id);
            $rootScope.customer_id = localStorage.getItem('customer_id');
            // sync local cart with remote cart
            var cart = eTakeAwayService.getLocalCart();
            if (cart.length) {
              cart.forEach(function (item) {
                delete item.name;
                delete item.price;
                delete item.total;
                if (item.remote_options) {
                  item.option = item.remote_options;
                  delete item.remote_options;
                }
                if (item.bundle) {
                  delete item.bundle;
                }
              })
              var checkoutPacket = {
                customer_id: res.success.customer_id,
                address_id: res.success.address_id,
                products: cart
              }
              eTakeAwayService.cartDetails(checkoutPacket)
                .then(function (res) {
                  eTakeAwayService.emptyLocalCart();
                  if ($stateParams.referrer == 'cart') {
                    $state.go('app.cartDetails');
                  }
                  console.log(res);
                }, function (err) {
                  console.log(err);
                })
            }
            if ($stateParams.referrer == 'cart') {
              $state.go('app.cartDetails');
            }
            if ($stateParams.referrer == 'feedback') {
              $state.go('app.feedback');
            }
            else if ($stateParams.referrer == 'account') {
              $state.go('app.accountDetail');
            }
            else {
              $state.go('app.main');
            }
          }
        }, function (error) {
          console.log(error);
        });
      };

      $scope.hide_msg = function () {
        $scope.alert = false;
      };

      $scope.customBack = function () {
        $state.go('app.welcome');
      }
    })

    .controller('registrationCtrl', function ($scope, $state, $stateParams, eTakeAwayService, $rootScope) {
      $scope.registerData = {};
      $scope.msg = "";
      $scope.alert = false;
      $scope.user = {};

      $scope.doRegister = function () {
//          console.log($scope.registerData.telephone);
//          console.log($scope.registerData);
          regaddress=JSON.parse(JSON.stringify($scope.registerData));
          regaddress.house_number=$scope.registerData.house_number + '\n' + $scope.registerData.street + '\n' + $scope.registerData.telephone;
//          regaddress.telephone=$scope.registerData.telephone;
          regaddress.street='';
        eTakeAwayService.register(regaddress,$scope.user).then(function (res) {
          if (res.error) {
            $scope.alert = true;
            $scope.msg = res.error;
          }
          else {
            localStorage.setItem('customer_id', res.success.customer_id);
            localStorage.setItem('address_id', res.success.address_id);
            $rootScope.customer_id = localStorage.getItem('customer_id');
            // sync local cart with remote cart
            var cart = eTakeAwayService.getLocalCart();
            if (cart.length) {
              cart.forEach(function (item) {
                delete item.name;
                delete item.price;
                delete item.total;
                if (item.remote_options) {
                  item.option = item.remote_options;
                  delete item.remote_options;
                }
                if (item.bundle) {
                  delete item.bundle;
                }
              });
              var checkoutPacket = {
                customer_id: res.success.customer_id,
                address_id: res.success.address_id,
                products: cart
              };
              eTakeAwayService.cartDetails(checkoutPacket)
                .then(function (res) {
                  eTakeAwayService.emptyLocalCart();
                  if ($stateParams.referrer == 'cart') {
                    $state.go('app.cartDetails');
                  }
//                  console.log(res);
                }, function (err) {
                  console.log(err);
                })
            }
            if ($stateParams.referrer == 'cart') {
              $state.go('app.cartDetails');
            }
            else if ($stateParams.referrer == 'feedback') {
              $state.go('app.feedback');
            }
            else if ($stateParams.referrer == 'account') {
              $state.go('app.accountDetail');
            }
            else {
              $state.go('app.main');
            }
          }
        }, function (error) {
          console.log(error);
        });
      };

      $scope.doSearchAddress = function () {
        eTakeAwayService.searchPostcode({postcode: $scope.registerData.postcode})
          .then(function (res) {
            if (res.error) {
              $scope.searchError = res.error;
            }
            else {
              $scope.registerData.city = res.postcode.city;
              $scope.registerData.street = res.postcode.street + ' ' + res.postcode.county;
              $scope.searchError = "";
            }
          }, function (err) {
            console.log(err);
          })
      };


      $scope.hide_msg = function () {
        $scope.alert = false;
      };

      $scope.customBack = function () {
        $state.go('app.welcome');
      }
    })

    .controller('Categories', function ($scope, $state, $ionicLoading, menu, storeInfo, storeStatus, $rootScope,$ionicModal) {
      $rootScope.parentCategoryID = [];
      $rootScope.parentCategoryIDForProducts = null;
      $rootScope.menu = menu;
      $scope.menu = [];
      $scope.storeInfo = {};
      $scope.storeStatus = storeStatus;

//      for (var i = 0; i < menu.rows.length; i++) {
//        $scope.menu.push(menu.rows.item(i));
//      }
      $scope.menu = menu; // JSON.parse(menu.rows.item(0));
      var weekday = new Array(7);
      weekday[0] = "sunday";
      weekday[1] = "monday";
      weekday[2] = "tuesday";
      weekday[3] = "wednesday";
      weekday[4] = "thursday";
      weekday[5] = "friday";
      weekday[6] = "saturday";
      var today = new Date();
      today = weekday[today.getDay()];
$scope.weekday_timings = storeInfo.store_times;
//      var temp_timings = {};
//      var weekday_timings = [];
//      temp_timings = storeInfo.store_times;
//
//      for (var item in temp_timings) {
//        var temp_obj = {};
//        temp_obj.day = item;
//        temp_obj.start = temp_timings[item][0].start;
//        temp_obj.end = temp_timings[item][0].end;
//
//        weekday_timings.push(temp_obj);
//      }
////      console.log(weekday_timings);
//      $scope.weekday_timings = weekday_timings;



      $scope.storeInfo.timings = storeInfo.store_times[today][0].start + '- ' + storeInfo.store_times[today][0].end;
      $scope.storeInfo.address = storeInfo.address;
      $scope.storeInfo.telephone = storeInfo.telephone;

      $scope.openModal = function(type){
        $scope.modalType = type;
        if(type == "hours")
        {
          $scope.modal.show();
        }
        else if(type == "delivery"){
          $scope.deliveryDetails = storeInfo.delivery_details;
          $scope.modal.show();
        }
        else if(type == "payment"){
          $scope.supportedPayments =[];
        for(i in storeInfo.payments){
            $scope.supportedPayments[$scope.supportedPayments.length]=String(storeInfo.payments[i]).replace(/<[^>]+>/gm, '');
        }
          $scope.modal.show();
        }
      };


      $ionicModal.fromTemplateUrl('templates/infoModal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        })
        .then(function (modal) {
          $scope.modal = modal;
        }, function (err) {
          console.log(err)
      });


      $scope.closeModal = function () {
        $scope.modal.hide();
      };


      $scope.loadProducts = function (category_id, description) {
        $rootScope.parentCategoryIDForProducts = category_id ;
        $state.go('app.products', {category_id: category_id, catDescription: description});
      };

      $scope.loadItemsOrSubcategories = function (item,itemkey) {
        if (!item.categories) {
          $scope.loadProducts(item.category_id, item.description);
        } else {
          $rootScope.subCategories = item.categories;
          $rootScope.parentCategoryID[$rootScope.parentCategoryID.length] = itemkey;
          $scope.loadSubCategories(item.description);
        }
      };

      $scope.loadSubCategories = function (description) {

          $state.go('app.subCategories', {catDescription: description});
      };

      $scope.customBack = function (){
        
        $state.go('app.main');
      };
    })

    .controller('SubCategories', function ($scope, $state, $stateParams, $ionicLoading,catDescription,  $rootScope, $ionicScrollDelegate) {
//      $rootScope.parentCategoryID = $stateParams.parent_id;
//      $scope.description = parentCategory.rows.item(0).description;
//      $scope.menu = [];
//      for (var i = 0; i < menu.rows.length; i++) {
//        $scope.menu.push(menu.rows.item(i));
//      }
      $scope.menu = $rootScope.subCategories;
      $scope.catDescription = catDescription;
      console.log(catDescription);
      $ionicLoading.hide();

      $scope.loadSubcategoriesOrProducts = function (item,itemkey) {
//        if (item.sub_categories == 'no') {
//          $scope.loadProducts(item.category_id, item.description)
//        }
//        else {
//          $scope.loadSubCategories(item.category_id)
//        }
        if (!item.categories) {
                  $rootScope.parentCategoryIDForProducts = item.category_id ;
                 $scope.loadProducts(item.category_id, item.description);
               } else {
                 $rootScope.subCategories = item.categories;
                 $rootScope.parentCategoryID[$rootScope.parentCategoryID.length] = itemkey;
                 $scope.loadSubCategories();
        }
      };


      $scope.loadProducts = function (category_id, description) {
        $state.go('app.products',
          {category_id: category_id, catDescription: description});
      };

      $scope.loadSubCategories = function () {
//        dbService.getMenu(parent_id)
//          .then(function (menu) {
//            $scope.menu = [];
//            for (var i = 0; i < menu.rows.length; i++) {
//              $scope.menu.push(menu.rows.item(i));
//            }
//          })
        $scope.menu = $rootScope.subCategories;
        $ionicScrollDelegate.scrollTop();
      };

      $scope.customBack = function () {
          // console.log($rootScope.parentCategoryID);
        $state.go('app.categories');
      };
    })

    .controller('Products', function ($scope, $state, products,catDescription,  $stateParams, $rootScope) {

//      if (!$rootScope.parentCategoryID) {
//        $rootScope.parentCategoryIDForProducts = $stateParams.category_id;
//      }

     // $scope.description = parentCategory.rows.item(0).description;

      $scope.products = [];
      $scope.catDescription = catDescription;
      //console.log(catDescription);
      for (var i = 0; i < products.rows.length; i++) {
        
        $scope.products.push(JSON.parse(products.rows.item(i).product));
      }

      $scope.loadOptions = function (product_id) {
        $state.go('app.productOptions', {product_id: product_id});
      };

      $scope.customBack = function () {
          // TODO  Back categories
          if($rootScope.parentCategoryID.length) {
              var menuitem = $rootScope.menu;
              for(var i in $rootScope.parentCategoryID ){
                  menuitem = menuitem[$rootScope.parentCategoryID[i]].categories;
              }
              $rootScope.subCategories = menuitem;
              // $rootScope.parentCategoryID[$rootScope.parentCategoryID.length] = item.category_id;
              $state.go('app.subCategories');
          }
          else {
        $state.go('app.categories');
      }
      }
    })

    .controller('ProductOptions', function ($scope, $state, $rootScope, product, eTakeAwayService) {
      $scope.forms = {}

      $scope.selectedQuantity = {value: 1};
      // $scope.product = dataset.rows.item(0);
      $scope.product = product ;

      // $scope.product.product_options = JSON.parse($scope.product.product_options);
      $scope.product.product_options = $scope.product.option;
      //var bundledItems = angular.fromJson($scope.product.bundle_items);

//      if (bundledItems.length == 0) {
//        $scope.isBundledDeal = true;
//      }
//      else {
//        $scope.isBundledDeal = false;
//      }
   // console.log( $scope.product);
    if ($scope.product.bundled_items.length) {
        $scope.isBundledDeal = true;
      }
      else {
        $scope.isBundledDeal = false;
      }
      $scope.totalPrice = ($scope.product.price ? $scope.product.price : '£0.00');
      // product options models
      $scope.selectOptions = [];
      $scope.textareaOptions = [];
      $scope.checkboxOptions = [];
      $scope.checkboxOptionsRequred = {};
      $scope.checkboxItems = [];
      // product bundle items models
      $scope.bundleProducts = [];
      $scope.bundleOptions = [];

      if ($scope.product.bundle_items != '') {
        var bundle_items =$scope.product.bundled_items;
        $scope.product.bundle_items = [];
        bundle_items.forEach(function (item, i) {
          bundle_items[i].bundled_qty = parseInt(bundle_items[i].bundled_qty);
          for (var j = 1; j <= bundle_items[i].bundled_qty; j++) {
            var bundle_item = {};
            bundle_item = $.extend({}, item); // create clone of item object
            bundle_item.qty_index = j;
            $scope.product.bundle_items.push(bundle_item);
          }
        });
      }

      // add to cart button settings
      $scope.addButton = {
        text: 'Add to cart',
        isDisable: false
      };

      function updatePrice() {
        var total = ($scope.product.price != false) ? $scope.product.price : '£0.00';
        total = total.split('£');
        total = parseFloat(total[1]);
        if ($scope.selectOptions.length) {
          $scope.selectOptions.forEach(function (item) {
            if (item && item.price) {
              var price = item.price.split('£');
              price = parseFloat(price[1]);
              total += price;
            }
          })
        }
        if ($scope.checkboxItems.length) {
          $scope.checkboxItems.forEach(function (item) {
            if (item.options_items.length) {
              item.options_items.forEach(function (options_item) {
                if (options_item.price) {
                  var price = options_item.price.split('£');
                  price = parseFloat(price[1]);
                  total += price;
                }
              })
            }
          })
        }
//        if ($scope.bundleProducts.length) {
//          $scope.bundleProducts.forEach(function (item) {
//            if (item.price) {
//              var price = parseFloat(item.price);
//              if (price) {
//                total += price;
//              }
//            }
//          })
//        }
        if ($scope.bundleOptions.length) {
          $scope.bundleOptions.forEach(function (item) {
            var selectPrice = 0.00;
            if (item.selectOptions.length) {
              item.selectOptions.forEach(function (selectOption) {
                if (selectOption.price) {
                  var price = selectOption.price.split('£');
                  price = parseFloat(price[1]);
                  selectPrice += price;
                  total += price;
                }
              })
            }
            if (item.checkboxItems.length) {
              var checkboxPrice = 0.00;
              item.checkboxItems.forEach(function (checkboxGroupKeys) {
                if (checkboxGroupKeys.options_items.length) {
                  checkboxGroupKeys.options_items.forEach(function (checkbox) {
                    if (checkbox.price) {
                      var price = checkbox.price.split('£');
                      price = parseFloat(price[1]);
                      checkboxPrice += price;
                      total += price;
                    }
                  })
                }
              });
            }
          })
        }

        total *= $scope.selectedQuantity.value;
        total = total.toFixed(2);
        $scope.totalPrice = '£' + total;
      }

      $scope.decreaseQuantity = function () {
        if ($scope.selectedQuantity.value != 1) {
          $scope.selectedQuantity.value--;
          updatePrice();
        }
      };

      $scope.increaseQuantity = function () {
        $scope.selectedQuantity.value++;
        updatePrice();
      };

      $scope.changeQuantity = function () {
        updatePrice();
      };

      $scope.updateSelectOptions = function (index, product_option_id, product_option_name) {
        if ($scope.selectOptions.length) {
          $scope.selectOptions[index].product_option_id = product_option_id;
          $scope.selectOptions[index].product_option_name = product_option_name;
        }
        updatePrice();
      };

      $scope.updateCheckboxOptions = function (product_option_id, product_option_name, index, item) {
        if ($scope.checkboxOptions[product_option_id][index]) {
          if (!$scope.checkboxItems[product_option_id]) {
            $scope.checkboxItems[product_option_id] = {};
            $scope.checkboxItems[product_option_id].options_items = [];
          }
          $scope.checkboxItems[product_option_id].product_option_id = product_option_id;
          $scope.checkboxItems[product_option_id].product_option_name = product_option_name;
          $scope.checkboxItems[product_option_id].options_items[index] = item;
          //
          $scope.checkboxOptionsRequred[product_option_id] = true;
        }
        else {
          delete $scope.checkboxItems[product_option_id].options_items[index];
            delflag = true;
            for(i in $scope.checkboxItems[product_option_id].options_items) {
                if($scope.checkboxItems[product_option_id].options_items[i]) {
                    delflag = false;
                    break;
                }
            }
            if (delflag) {
                delete $scope.checkboxOptionsRequred[product_option_id];
            }
            
        }
        updatePrice();
      };

      $scope.updateTextareaOptions = function (product_option_id, product_option_name) {
        $scope.textareaOptions[product_option_id].product_option_name = product_option_name;
      };

      $scope.selectBundleProduct = function (index, bundled_id, qty_index) {
        $scope.bundleProducts[index].bundled_id = bundled_id;
        $scope.bundleProducts[index].qty_index = qty_index - 1;
        $scope.bundleOptions[index] = {};
        $scope.bundleOptions[index].bundled_id = bundled_id;
        $scope.bundleOptions[index].selectOptions = [];
        $scope.bundleOptions[index].checkboxOptions = [];
        $scope.bundleOptions[index].checkboxItems = [];
        $scope.bundleOptions[index].textareaOptions = [];
        /* #JYOTHISH
        var productPrice = parseFloat($scope.bundleProducts[index].price);
        if (productPrice) {
          updatePrice();
        } */
      };

      $scope.bundleSelectOptions = function (bundleIndex, selectOptionIndex, product_option_id, product_option_name) {
        $scope.bundleOptions[bundleIndex].selectOptions[selectOptionIndex].product_option_id = product_option_id;
        $scope.bundleOptions[bundleIndex].selectOptions[selectOptionIndex].product_option_name = product_option_name;
        if ($scope.bundleOptions[bundleIndex].selectOptions[selectOptionIndex].price) {
          updatePrice();
        }
      };

      $scope.bundleCheckboxOptions = function (bundleIndex, checkboxIndex, checkbox, product_option_id, product_option_name, item) {
        if ($scope.bundleOptions[bundleIndex].checkboxOptions[checkboxIndex][checkbox]) {
          if (!$scope.bundleOptions[bundleIndex].checkboxItems) {
            $scope.bundleOptions[bundleIndex].checkboxItems = [];
          }
          if (!$scope.bundleOptions[bundleIndex].checkboxItems[checkboxIndex]) {
            $scope.bundleOptions[bundleIndex].checkboxItems[checkboxIndex] = {};
            $scope.bundleOptions[bundleIndex].checkboxItems[checkboxIndex].product_option_id = product_option_id;
            $scope.bundleOptions[bundleIndex].checkboxItems[checkboxIndex].product_option_name = product_option_name;
            $scope.bundleOptions[bundleIndex].checkboxItems[checkboxIndex].options_items = [];
          }
          $scope.bundleOptions[bundleIndex].checkboxItems[checkboxIndex].options_items[checkbox] = item;
        }
        else {
          delete $scope.bundleOptions[bundleIndex].checkboxItems[checkboxIndex].options_items[checkbox];
        }
        updatePrice();
      };

      $scope.addItemToCart = function () {
        var product = {};
        product.product_id = $scope.product.product_id;
        product.option = {};
        if ($scope.selectOptions.length) {

          $scope.selectOptions.forEach(function (item) {
            product.option[item.product_option_id] = item.product_option_value_id;
          })
        }

        if ($scope.checkboxItems.length) {
          $scope.checkboxItems.forEach(function (item) {
            product.option[item.product_option_id] = [];
            if (item.options_items) {
              item.options_items.forEach(function (options_item) {
                product.option[item.product_option_id].push(options_item.product_option_value_id);
              })
            }
          })
        }

        if ($scope.textareaOptions.length) {
          $scope.textareaOptions.forEach(function (item, i) {
            product.option[i] = item.value;
          })
        }

        if ($scope.bundleProducts.length) {
          var bundled_product = [];
          $scope.bundleProducts.forEach(function (item) {
            var qty_index = parseInt(item.qty_index);
            var key = item.bundled_id + '_' + qty_index + '_' + item.product_id;
            bundled_product.push(key);
          });
          product.bundled_product = bundled_product;
        }

        if ($scope.bundleOptions.length) {
          var bundledoption = {};
          product.bundled_product.forEach(function (item, i) {
            var keys = item.split('_');

            if ($scope.bundleOptions[i].selectOptions) {
              bundledoption[item] = {};

              for (var selectOption in $scope.bundleOptions[i].selectOptions) {
                bundledoption[item][$scope.bundleOptions[i].selectOptions[selectOption].product_option_id] = $scope.bundleOptions[i].selectOptions[selectOption].product_option_value_id;
              }
            }

            if ($scope.bundleOptions[i].checkboxItems) {
              $scope.bundleOptions[i].checkboxItems.forEach(function (checkboxGroup) {
                if (checkboxGroup.options_items.length) {
                  if (!bundledoption[item]) {
                    bundledoption[item] = {};
                  }
                  bundledoption[item][checkboxGroup.product_option_id] = [];
                  checkboxGroup.options_items.forEach(function (options_item) {
                    bundledoption[item][checkboxGroup.product_option_id].push(options_item.product_option_value_id);
                  })
                }
              })
            }
            // console.log('textareaOptions');
            // console.log($scope.bundleOptions[i].textareaOptions[keys[1]]);
          });
          product.bundledoption = bundledoption;
        }

        product.quantity = $scope.selectedQuantity.value;

        var customer_id = localStorage.getItem('customer_id');
        if (customer_id) {
          var products = [];
          // console.log(product);
          products.push(product);
          var checkoutPacket = {
            customer_id: customer_id,
            products: products
          };
          eTakeAwayService.cartDetails(checkoutPacket)
            .then(function (res) {
              // console.log(res);
              disabledAddButton();
              /* if ($rootScope.parentCategoryID != null) {
                $state.go('app.subCategories', {parent_id: $rootScope.parentCategoryID});
              }
              else {
                if ($rootScope.parentCategoryIDForProducts) {
                  $state.go('app.products', {category_id: $rootScope.parentCategoryIDForProducts});
                }
                else {
                  $state.go('app.categories');
                }
              }
              */
             if ($rootScope.parentCategoryIDForProducts) {
              $state.go('app.products', {category_id: $rootScope.parentCategoryIDForProducts});
             }
                else {
              $state.go('app.categories');
                }
            }, function (err) {
              console.log(err);
            });
        }
        else {
          product.remote_options = product.option;
          product.option = [];
          if ($scope.selectOptions.length) {
            $scope.selectOptions.forEach(function (item) {
              var selectOption = {};
              selectOption.name = item.product_option_name;
              selectOption.value = item.name;
              selectOption.type = 'select';
              product.option.push(selectOption);
            })
          }
          if ($scope.checkboxItems.length) {
            $scope.checkboxItems.forEach(function (item) {
              if (item.options_items.length) {
                item.options_items.forEach(function (option) {
                  var checkbox = {};
                  checkbox.name = item.product_option_name;
                  checkbox.value = option.name;
                  checkbox.type = 'checkbox';
                  product.option.push(checkbox);
                })
              }
            })
          }
          if ($scope.textareaOptions.length) {
            $scope.textareaOptions.forEach(function (item) {
              var textareaOption = {};
              textareaOption.name = item.product_option_name;
              textareaOption.value = item.value;
              textareaOption.type = 'textarea';
              product.option.push(textareaOption);
            })
          }
          if ($scope.bundleProducts.length) {
            var bundle = [];
            $scope.bundleProducts.forEach(function (item, i) {
              var quantity = item.bundled_qty;
              for (var q = 0; q < quantity; q++) {
                var bundleProduct = {};
                bundleProduct.product_id = item.product_id;
                bundleProduct.name = item.name;
                bundleProduct.model = item.model;
                bundleProduct.option = [];
                if ($scope.bundleOptions[i].selectOptions.length) {
                  for (var selectOption in $scope.bundleOptions[i].selectOptions[q]) {
                    var optionItem = {};
                    optionItem.name = $scope.bundleOptions[i].selectOptions[q][selectOption].product_option_name;
                    optionItem.value = $scope.bundleOptions[i].selectOptions[q][selectOption].name;
                    optionItem.type = 'select';
                    bundleProduct.option.push(optionItem);
                  }
                }
                if ($scope.bundleOptions[i].checkboxItems.length) {
                  $scope.bundleOptions[i].checkboxItems[q].forEach(function (checkboxItem) {
                    if (checkboxItem.options_items.length) {
                      checkboxItem.options_items.forEach(function (checkbox) {
                        var optionItem = {};
                        optionItem.name = checkboxItem.product_option_name;
                        optionItem.value = checkbox.name;
                        optionItem.type = 'checkbox';
                        bundleProduct.option.push(optionItem);
                      })
                    }
                  })
                }
                bundle.push(bundleProduct);
              }
            });
            product.bundle = bundle;
          }

          product.productKey = Date.now();
          product.name = $scope.product.name;
          product.total = $scope.totalPrice;
          var price = $scope.totalPrice;
          price = price.split('£');
          price = parseFloat(price[1]);
          price /= product.quantity;
          price = price.toFixed(2);
          product.price = '£' + price;
          // console.log(product);
          eTakeAwayService.addToLocalCart(product);
          disabledAddButton();
          /* if ($rootScope.parentCategoryID != null) {
            $state.go('app.subCategories', {parent_id: $rootScope.parentCategoryID});
          }
          else {
            if ($rootScope.parentCategoryIDForProducts) {
              $state.go('app.products', {category_id: $rootScope.parentCategoryIDForProducts});
            }
            else {
              $state.go('app.categories');
            }
          } */
          if ($rootScope.parentCategoryIDForProducts) {
              $state.go('app.products', {category_id: $rootScope.parentCategoryIDForProducts});
          }
            else {
              $state.go('app.categories');
            } 

        }
      };

      function disabledAddButton() {
        $scope.addButton.text = 'Product added to cart';
        $scope.addButton.isDisable = true;
      };

      $scope.getTimes = function (n) {
        return new Array(parseInt(n));
      };

      $scope.customBack = function () {
        // $state.go('app.categories');
        if ($rootScope.parentCategoryIDForProducts) {
              $state.go('app.products', {category_id: $rootScope.parentCategoryIDForProducts});
            }
        else {
        $state.go('app.categories');
        }
      };
    })

    .controller('CartDetails', function ($scope, $state, eTakeAwayService, cart, $ionicPopup, storeStatus, $rootScope, $ionicLoading) {
      $scope.allowOnlineOrders = true;
      $ionicLoading.hide();
      if (cart && cart.hasOwnProperty('closed_message_head')) {
        $scope.allowOnlineOrders = false;
        $scope.closedMessageHeader = cart.closed_message_head;
        $scope.closedMessageContent = cart.closed_message_content;
        eTakeAwayService.getStoreInfo().then(function (res) {
          //console.log(res.store_times);
          $scope.weekday_timings = res.store_times;
//          var temp_timings = {};
//          var weekday_timings = [];
//          temp_timings = res.store_times;

//          for (var item in temp_timings) {
//            var temp_obj = {};
//            temp_obj.day = item;
//            temp_obj.start = temp_timings[item][0].start;
//            temp_obj.end = temp_timings[item][0].end;
//
//            weekday_timings.push(temp_obj);
//          }
     //     console.log(weekday_timings);
//          $scope.weekday_timings = weekday_timings;

          $scope.telephone = res.telephone;
//                    $scope.storeInfo = res;
        }, function (err) {
          console.log(err);
        });
      }

      $scope.viewTitle = "Cart Details";
      $scope.cart = [];
      $scope.voucher = {code: ""};
      $scope.coupon = {code: ""};
      $scope.reward = {points: ""};
      $scope.showError = false;
      $scope.errorMsg = "";
      $scope.remoteCart = false;
      $scope.showDiscountSection = false;
      $scope.showVoucherSection = false;
      $scope.showCouponSection = false;
      $scope.showRewardPointsSection = false;
      $scope.disableVoucherButton = true;
      $scope.disableCouponButton = true;
      $scope.disableRewardButton = true;
      $scope.subTotal = "";
      $scope.totalSection = [];
      $scope.rewardMax = 0;
      $scope.shippingMessages = [];
      if (cart && cart.hasOwnProperty('shipping_warnings')) {
        $scope.shipping_warnings = cart.shipping_warnings;
      }
      else {
        $scope.shipping_warnings = [];

      }
      $scope.storeStatus = storeStatus

      if (cart) {
        loadRemoteCart(cart);
      }
      else {
        $scope.cart = eTakeAwayService.getLocalCart();
      }

      if ($scope.cart.length) {
        $scope.empty = false;
      }
      else {
        $scope.empty = true;
      }

      function loadRemoteCart(cart) {
        $scope.cart = [];
        $scope.remoteCart = true;
        // convert cart object into array
        for (var key in cart.products) {
          var product = cart.products[key];
          product.productKey = key;
          $scope.cart.push(product);
        }

        // store shipping_methodes in eTakeAwayService
        var methods = [];
        for (var key in cart.shipping_methodes) {
          var method = cart.shipping_methodes[key];
          if (method.msg != "") {
            var message = method.title + ': ' + method.msg;
            $scope.shippingMessages.push(message);
          }
          for (var item in method.quote) {
            method.methodKey = method.quote[item].code;
            if (method.quote[item].code == "home.home") {
              eTakeAwayService.setDeliveryCharges(method.quote[item].text);
            }
          }
          methods.push(method);
        }
        eTakeAwayService.setShippingMethods(methods);

        // store payment_methodes in eTakeAwayService
        methods = [];
        for (var key in cart.payment_methodes) {
          methods.push(cart.payment_methodes[key]);
        }
        eTakeAwayService.setPaymentMethods(methods);

        // get sub total from remote cart
        if (cart.totals.length) {
          cart.totals.forEach(function (item) {
            if (item.code == 'sub_total') {
              $scope.subTotal = item.text;
            }
          })
          updateTotalSection(cart.totals);
        }

        if (cart.voucher == 'yes') {
          $scope.showDiscountSection = true;
          $scope.showVoucherSection = true;
        }
        if (cart.coupon == 'yes') {
          $scope.showDiscountSection = true;
          $scope.showCouponSection = true;
        }
        if (cart.reward == 'yes') {
          $scope.showDiscountSection = true;
          $scope.showRewardPointsSection = true;
          $scope.rewardMax = cart.reward_points;
        }
      }

      $scope.decreaseQuantity = function (index) {
        if ($scope.cart[index].quantity != 1) {
          if ($scope.remoteCart) {
            $scope.cart[index].quantity--;
            var updatePakcet = {
              customer_id: localStorage.getItem('customer_id'),
              update: $scope.cart[index].productKey,
              quantity: $scope.cart[index].quantity
            }
            eTakeAwayService.cartDetails(updatePakcet)
              .then(function (res) {
                if (res.error) {
                  console.log(res.error);
                  $scope.cart[index].quantity++;
                }
                else {
                  loadRemoteCart(res);
                }
              }, function (err) {
                console.log(err);
              })
          }
          else {
            eTakeAwayService.updateProductLocal($scope.cart[index].productKey, $scope.cart[index].quantity - 1);
          }
        }
      }

      $scope.increaseQuantity = function (index) {
        if ($scope.remoteCart) {
          $scope.cart[index].quantity++;
          var updatePakcet = {
            customer_id: localStorage.getItem('customer_id'),
            update: $scope.cart[index].productKey,
            quantity: $scope.cart[index].quantity
          }
          eTakeAwayService.cartDetails(updatePakcet)
            .then(function (res) {
              if (res.error) {
                console.log(res.error);
                $scope.cart[index].quantity--;
              }
              else {
                loadRemoteCart(res);
              }
            }, function (err) {
              console.log(err);
            })
        }
        else {
          eTakeAwayService.updateProductLocal($scope.cart[index].productKey, $scope.cart[index].quantity + 1);
        }
      }

      function updateTotalSection(totals) {
        $scope.totalSection = [];
        totals.forEach(function (item) {
          if ((item.code == 'offers' && item.text) || (item.code == 'voucher' && item.text) || (item.code == 'coupon' && item.text) || (item.code == 'reward' && item.text) || (item.code == 'total' && item.text) || (item.code == 'sub_total' && item.text)) {
            $scope.totalSection.push(item);
          }
        });
      }

      $scope.confirmDelete = function (productKey, index, product_id) {
        var confirmPopup = $ionicPopup.confirm({
          title: 'Confirm Remove',
          template: 'Are you sure you want to remove this item from cart?'
        });

        confirmPopup.then(function (res) {
          if (res) {
            $scope.removeItem(productKey, index, product_id)
          } else {
            console.log('You are not sure');
          }
        });

      }

      $scope.removeItem = function (productKey, index, product_id) {
        var customer_id = localStorage.getItem('customer_id');
        if (customer_id) {
          var cartPacket = {
            customer_id: customer_id,
            remove: productKey
          };
          eTakeAwayService.cartDetails(cartPacket)
            .then(function (res) {
              $scope.cart.splice(index, 1);
              updateTotalSection(res.totals);
            }, function (err) {
              console.log(err);
            })
        }
        else {
          eTakeAwayService.removeFromLocalCart(productKey);
          $scope.cart = eTakeAwayService.getLocalCart();
        }
      }

      $scope.setVoucherStatus = function () {
        if ($scope.voucher.code) {
          $scope.disableVoucherButton = false;
        }
        else {
          $scope.disableVoucherButton = true;
        }
      }

      $scope.setCouponStatus = function () {
        if ($scope.coupon.code) {
          $scope.disableCouponButton = false;
        }
        else {
          $scope.disableCouponButton = true;
        }
      }

      $scope.setRewardStatus = function () {
        var points = parseInt($scope.reward.points);
        var max = parseInt($scope.rewardMax);
        if (points && points <= max) {
          $scope.disableRewardButton = false;
        }
        else {
          $scope.disableRewardButton = true;
        }
      }

      $scope.userVoucher = function () {
        var cartPacket = {
          customer_id: localStorage.getItem('customer_id'),
          voucher: $scope.voucher.code
        }
        eTakeAwayService.cartDetails(cartPacket)
          .then(function (res) {
            if (res.error_voucher) {
              $scope.errorMsg = res.error_voucher;
              $scope.showError = true;
            }
            else {
              updateTotalSection(res.totals);
              eTakeAwayService.setVoucher($scope.voucher.code);
              console.log(res);
              $scope.errorMsg = "";
              $scope.showError = false;
            }
          }, function (err) {
            console.log(err);
          })
      };

      $scope.userCoupon = function () {
        var cartPacket = {
          customer_id: localStorage.getItem('customer_id'),
          coupon: $scope.coupon.code
        };
        eTakeAwayService.cartDetails(cartPacket)
          .then(function (res) {
            if (res.error_coupon) {
              $scope.errorMsg = res.error_coupon;
              $scope.showError = true;
            }
            else {
              updateTotalSection(res.totals);
              eTakeAwayService.setCoupon($scope.coupon.code);
              console.log(res);
              $scope.errorMsg = "";
              $scope.showError = false;
            }
          }, function (err) {
            console.log(err);
          })
      }

      $scope.rewardPoints = function () {
        var cartPacket = {
          customer_id: localStorage.getItem('customer_id'),
          reward: $scope.reward.points
        };
        eTakeAwayService.cartDetails(cartPacket)
          .then(function (res) {
            if (res.error_reward) {
              $scope.errorMsg = res.error_reward;
              $scope.showError = true;
            }
            else {
              updateTotalSection(res.totals);
              eTakeAwayService.setReward($scope.reward.points);
              console.log(res);
              $scope.errorMsg = "";
              $scope.showError = false;
            }
          }, function (err) {
            console.log(err);
          })
      };

      $scope.checkoutCart = function () {
        if ($scope.allowOnlineOrders || $rootScope.debug) {
          if (localStorage.getItem('customer_id')) {
            $state.go('app.shippingMethod');
            //$state.go('app.deliveryAddress');
          }
          else {
            $state.go('app.welcome', {referrer: 'cart'});
          }
        }
        else {
          var alertPopup = $ionicPopup.alert({
            title: '<b>Store Closed</b>',
            template: '<b>We are sorry but store is closed at the moment and not accepting online orders</b>',
            okType: 'button-assertive'
          });
        }
      }

      $scope.customBack = function () {
        $state.go('app.categories');
      }

    })

    .controller('ShippingMethod', function ($scope, $state, eTakeAwayService,cart,$ionicModal,$location,$ionicPopup,$ionicLoading) {
      $scope.shipping_methodes = eTakeAwayService.getShippingMethods();
      $scope.shippingMessages = [];
      $scope.shipping_warnings = cart.shipping_warnings;
      $scope.hasShippingWarnings = Object.keys($scope.shipping_warnings).length;
      $scope.newAddressAdded = false;

      var methods = [];
      for (var key in cart.shipping_methodes) {
        var method = cart.shipping_methodes[key];
        if (method.msg != "") {
          var message = method.title + ': ' + method.msg;
          $scope.shippingMessages.push(message);
        }
        for (var item in method.quote) {
          method.methodKey = method.quote[item].code;
          if (method.quote[item].code == "home.home") {
            eTakeAwayService.setDeliveryCharges(method.quote[item].text);
          }
        }
        methods.push(method);
      }
      $scope.shipping_methodes = methods;

      $scope.saveShippingMethod = function (methodName) {
        eTakeAwayService.setSelectedShippingMethod(methodName);
        localStorage.setItem("shipping_method",methodName);
        if(methodName == 'collect.collect'){
          $state.go('app.deliveryAddress');
        }
        else
        {
          if($scope.newAddressAdded)
          {
            var address_id = localStorage.getItem('address_id');
            $location.path('app/deliveryAddress/'+address_id);
          }
          else
          {
            $state.go('app.chooseAddress');
          }


        }
        //$state.go('app.paymentMethod');
      };

      $scope.customBack = function () {
        $state.go('app.cartDetails');
      };

      $scope.newAddress = {};

      $scope.doSearchAddress = function () {
        eTakeAwayService.searchPostcode({postcode: $scope.newAddress.postcode})
          .then(function (res) {
            if (res.error) {
              $scope.searchError = res.error;
            }
            else {
              $scope.searchError = "";
              $scope.newAddress.address = res.postcode.street + ', ' + res.postcode.city + ' ' + res.postcode.county;
            }
          }, function (err) {
            console.log(err);
          })
      };

      $scope.addNewAddress = function() {
        $scope.newAddress.customer_id = localStorage.getItem('customer_id');
       // $scope.newAddress.address = $scope.newAddress.houseno + " " + $scope.newAddress.address;
        localStorage.setItem('phoneNumber', '');
        newaddress=$scope.newAddress;
        newaddress=JSON.parse(JSON.stringify($scope.newAddress))
        newaddress.address=newaddress.houseno + '\n' + newaddress.address+ '\n' + newaddress.telephone;
        //newaddress.address=newaddress.address.split('\n');
        //newaddress.houseno=newaddress.address[0];
        //console.log(newaddress.address[0]);
        eTakeAwayService.addAddress(newaddress)
          .then(function (res) {
            if (res.error) {
              $scope.errorMsg = res.error;
            }
            else {
              localStorage.setItem('phoneNumber', $scope.newAddress.telephone);
              localStorage.setItem('address_id', res.success.address_id);
              $scope.checkAddress(res.success.address_id);
              //$location.path('app/deliveryAddress/'+res.success.address_id);
            }
          }, function (err) {
            console.log(err);
          });
      };

      $scope.setSearchAddressButtonStatus = function () {
        if ($scope.newAddress.postcode) {
          $scope.disableSearchAddressButton = false;
          $scope.searchError = "";
        }
        else {
          $scope.disableSearchAddressButton = true;
        }
      };

     $scope.newaddressData = function(){
           $scope.addressstatus = true;
           
           if($scope.newAddress.postcode==undefined){
               
                   $scope.addressstatus = false;
           }
           if($scope.newAddress.address==undefined){
               
                   $scope.addressstatus = false;
           }
           if(($scope.newAddress.firstname==undefined) && ($scope.newAddress.lastname==undefined)){
               
                   $scope.addressstatus = false;
           }
           /*
           if($scope.newAddress.lastname==undefined){
               
                   $scope.addressstatus = false;
           }
           */
           if($scope.newAddress.houseno==undefined){
               
                   $scope.addressstatus = false;
           }
           if($scope.newAddress.telephone==undefined){
               
                   $scope.addressstatus = false;
           }
           //console.log(status);
           //return status;
    };
    
      $ionicModal.fromTemplateUrl('templates/addAddressModal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        })
        .then(function (modal) {
          $scope.modal = modal;
        }, function (err) {
          console.log(err)
      });

      $scope.openNewAddressModal = function () {
        $scope.modal.show();
      };

      $scope.closeModal = function () {
        $scope.modal.hide();
      };

      $scope.checkAddress = function (address_id){
        var customer_id = localStorage.getItem('customer_id');
        var address_id = address_id;
        var shipping_method = localStorage.getItem("shipping_method");
        var cartData = {
          customer_id: customer_id,
          address_id: address_id,
          shipping_method: shipping_method
        };
        $ionicLoading.show();
        eTakeAwayService.cartDetails(cartData)
          .then(function(res)
          {
            if(Object.keys(res.shipping_warnings).length)
            {
              var alertPopup = $ionicPopup.alert({
                title: "Not available",
                template: '<p>'+res.shipping_warnings.home+'</p>',
                okType: 'button-assertive'
              });
            }
            else
            {
              $scope.closeModal();
              $scope.newAddressAdded = true;
              //$location.path('app/deliveryAddress/'+address_id);
            }
            $ionicLoading.hide();
          },function(err)
          {
            $ionicLoading.hide();
          });
      };

    })

    .controller('ChooseAddressCtrl',function($scope,addresses,$ionicModal,eTakeAwayService,$location,$ionicLoading,$ionicPopup){
      $scope.addresses = addresses;
      $scope.newAddress = {};

      $scope.doSearchAddress = function () {
        eTakeAwayService.searchPostcode({postcode: $scope.newAddress.postcode})
          .then(function (res) {
            if (res.error) {
              $scope.searchError = res.error;
            }
            else {
              $scope.searchError = "";
              $scope.newAddress.address = res.postcode.street + ', ' + res.postcode.city + ' ' + res.postcode.county;
            }
          }, function (err) {
            console.log(err);
          })
      };

      $scope.addNewAddress = function() {
        $scope.newAddress.customer_id = localStorage.getItem('customer_id');
        // $scope.newAddress.address = $scope.newAddress.houseno + " " + $scope.newAddress.address;
        localStorage.setItem('phoneNumber', '');
        newaddress=$scope.newAddress;
        newaddress=JSON.parse(JSON.stringify($scope.newAddress))
        newaddress.address=newaddress.houseno + '\n' + newaddress.address + '\n' + newaddress.telephone;
        
        eTakeAwayService.addAddress(newaddress)
          .then(function (res) {
            if (res.error) {
              $scope.errorMsg = res.error;
            }
            else {
              localStorage.setItem('phoneNumber', $scope.newAddress.telephone);
              localStorage.setItem('address_id', res.success.address_id);
              $scope.checkAddress(res.success.address_id);
              //$location.path('app/deliveryAddress/'+res.success.address_id);
            }
          }, function (err) {
            console.log(err);
          });
      };

      $scope.setSearchAddressButtonStatus = function () {
        if ($scope.newAddress.postcode) {
          $scope.disableSearchAddressButton = false;
          $scope.searchError = "";
        }
        else {
          $scope.disableSearchAddressButton = true;
        }
      };

$scope.newaddressData = function(){
           $scope.addressstatus = true;
           
           if($scope.newAddress.postcode==undefined){
               
                   $scope.addressstatus = false;
           }
           if($scope.newAddress.address==undefined){
               
                   $scope.addressstatus = false;
           }
           if(($scope.newAddress.firstname==undefined) && ($scope.newAddress.lastname==undefined)){
               
                   $scope.addressstatus = false;
           }
           /*
           if($scope.newAddress.lastname==undefined){
               
                   $scope.addressstatus = false;
           }
           */
           if($scope.newAddress.houseno==undefined){
               
                   $scope.addressstatus = false;
           }
           if($scope.newAddress.telephone==undefined){
               
                   $scope.addressstatus = false;
           }
           //console.log(status);
           //return status;
    };                  
      $scope.checkAddress = function (address_id){
//          console.log(address_id);
           localStorage.setItem('address_id', address_id);
        $scope.closeModal();
        var customer_id = localStorage.getItem('customer_id');
        var address_id = address_id;
        var shipping_method = localStorage.getItem("shipping_method");
        var cartData = {
          customer_id: customer_id,
          address_id: address_id,
          shipping_method: shipping_method
        };
        $ionicLoading.show();
        eTakeAwayService.cartDetails(cartData)
        .then(function(res)
        {
          if(Object.keys(res.shipping_warnings).length)
          {
            var alertPopup = $ionicPopup.alert({
              title: "Not available",
              template: '<p>'+res.shipping_warnings.home+'</p>',
              okType: 'button-assertive'
            });
          }
          else
          {
            $location.path('app/deliveryAddress/'+address_id);
          }
          $ionicLoading.hide();
        },function(err)
        {
          $ionicLoading.hide();
        });
      };
      //new address Modal
      $ionicModal.fromTemplateUrl('templates/addAddressModal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        })
        .then(function (modal) {
          $scope.modal = modal;
        }, function (err) {
          console.log(err)
      });

      $scope.openNewAddressModal = function () {
        $scope.modal.show();
      };

      $scope.closeModal = function () {
        $scope.modal.hide();
      };
    })

    .controller('DeliveryAddress', function ($scope, $state, $cordovaInAppBrowser, $rootScope, eTakeAwayService, addresses, cartService, cart, customer, $ionicModal,$stateParams,$ionicPopup,$ionicLoading,$ionicNavBarDelegate) {

      // 
      $scope.waitingForConfirm = false;
      $scope.temp ={};
      $scope.shipping_methodes = [];
      $scope.payment_methodes = [];
      $scope.shippingMessages = [];
      var closeFromSuccess = false;
      $scope.shipping_warnings = cart.shipping_warnings;
      var methods = [];
      for (var key in cart.shipping_methodes) {
        var method = cart.shipping_methodes[key];
        if (method.msg != "") {
          var message = method.title + ': ' + method.msg;
          $scope.shippingMessages.push(message);
        }
        for (var item in method.quote) {
          method.methodKey = method.quote[item].code;
          if (method.quote[item].code == "home.home") {
            eTakeAwayService.setDeliveryCharges(method.quote[item].text);
          }
        }
        methods.push(method);
      }
      eTakeAwayService.setShippingMethods(methods);

      // store payment_methodes in eTakeAwayService
      methods = [];
      for (var key in cart.payment_methodes) {
        methods.push(cart.payment_methodes[key]);
      }
      eTakeAwayService.setPaymentMethods(methods);

      $scope.addresses = [];
      $scope.selectedAddress = {address_id: localStorage.getItem('address_id')};
      $scope.radioGroup = {};
      $scope.newAddress = {};
      $scope.deliveryTimings = [];
      $scope.selectedTime = {timestamp: 0};
      $scope.errorMsg = "";
      $scope.comment = {text: ""};
      $scope.disableSearchAddressButton = true;
      $scope.disableConfirmButton = false;
      $scope.searchError = "";
      $scope.cb1 = {'selected': false}

      //$scope.shipping_methodes = eTakeAwayService.getShippingMethods();

      $scope.selectedShippingMethod = eTakeAwayService.getSelectedShippingMethod();
      $scope.payment_methodes = eTakeAwayService.getPaymentMethods();

//            $scope.shippingRadio = {'shippingMethod':}


      for (var key in $scope.payment_methodes) {
        if ($scope.payment_methodes[key].code == 'cod') {
          $scope.payment_methodes[key].title2 = 'Cash On Delivery';
        }
        else if ($scope.payment_methodes[key].code == 'pp_standard') {
          $scope.payment_methodes[key].title2 = 'PayPal';
        }
        else if ($scope.payment_methodes[key].code == 'stripe_payments') {
          $scope.payment_methodes[key].title2 = 'Credit / Debit Card';
        }
        else
        {
            $scope.payment_methodes[key].title2 = String($scope.payment_methodes[key].title).replace(/<[^>]+>/gm, '')
        }
      }

      var getPaymentMethodTitle = function (method) {
        var title;
        for (var key in $scope.payment_methodes) {
          if ($scope.payment_methodes[key].code == method) {
            title = $scope.payment_methodes[key].title2;
          }
        }
        return title
      };

      var getdeliveryMethodTitle = function (key) {
        var title;
        $scope.shipping_methodes = eTakeAwayService.getShippingMethods();
        $scope.shipping_methodes.forEach(function (method) {
          if (method.methodKey == key) {
            title = method.title;
          }
        });
        return title;
      };

      $scope.paymentRadio = {};
      $scope.shippingRadio = {};

      for (var property in addresses) {
        var address = {};
        address.address_id = addresses[property].address_id;
        address.addressValue = addresses[property].address_1 + ' ' + addresses[property].address_2;
        $scope.addresses.push(address);
      }

      var index = 0;
      for (var property in cart.requested_times) {
        var timeBuffer = {
          unixtime: property,
          timeValue: cart.requested_times[property]
        }
        if (index == 0) {
          $scope.selectedTime.timestamp = property;
        }
        $scope.deliveryTimings.push(timeBuffer);
        index++;
      }

      $scope.selectAddress = function () {
        console.log('address_id =', $scope.selectedAddress.address_id);
        localStorage.setItem('address_id', $scope.selectedAddress.address_id);
      }

      $scope.setSearchAddressButtonStatus = function () {
        if ($scope.newAddress.postcode) {
          $scope.disableSearchAddressButton = false;
          $scope.searchError = "";
        }
        else {
          $scope.disableSearchAddressButton = true;
        }
      }

      $scope.doSearchAddress = function () {
        eTakeAwayService.searchPostcode({postcode: $scope.newAddress.postcode})
          .then(function (res) {
            if (res.error) {
              $scope.searchError = res.error;
            }
            else {
              $scope.searchError = "";
              $scope.newAddress.address = res.postcode.street + ', ' + res.postcode.city + ' ' + res.postcode.county;
            }
          }, function (err) {
            console.log(err);
          })
      }

      var getAddress = function () {
          var address;
          var adr;
          var address_id = parseInt(localStorage.getItem('address_id'));
          for (var key in addresses) {
            //  console.log(key + '==' +  address_id );
            if (key == address_id) {
              adr = addresses[key];
            }
          }
          address = adr.firstname + ' ' + adr.lastname + ' ' + adr.address_1 + ' ,' + adr.address_2 + ' ' + adr.postcode;
          return address;
      };

      var getPhoneNumber = function () {
        var phoneNumber = localStorage.getItem('phoneNumber');
        if(phoneNumber){
          return phoneNumber;
        }
        else {
          return customer.telephone;
        }
      };

      var getTime = function () {

        if ($scope.cb1.selected) {
          return "ASAP";
        }
        else {
          var deliveryTime;
          $scope.deliveryTimings.forEach(function (time) {
            if ($scope.selectedTime.timestamp == time.unixtime) {
              deliveryTime = time.timeValue;
            }
          });
          return deliveryTime;
        }
      };

      $ionicModal.fromTemplateUrl('templates/confirm-order-modal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        })
        .then(function (modal) {
          $scope.modal = modal;
        }, function (err) {
          console.log(err)
      });

      $scope.openConfirmOrderModal = function () {
        $scope.paymentMethodTitle = getPaymentMethodTitle($scope.paymentRadio.method);
        if(!$scope.selectedShippingMethod.length)
        {
            $scope.selectedShippingMethod = localStorage.getItem("shipping_method");
        }
        $scope.deliveryMethodTitle = getdeliveryMethodTitle($scope.selectedShippingMethod);
        if($scope.paymentRadio.method == 'cod' && $scope.selectedShippingMethod == 'collect.collect')
        {
          $scope.paymentMethodTitle = "Cash on collection";
        }
        $scope.address = getAddress();
        $scope.phoneNumber = getPhoneNumber();
        $scope.deliveryTime = getTime();
        
        // $scope.modal.show();
         reviewRequest($stateParams.address_id);
      };

      $scope.closeConfirmModal = function () {
        $scope.modal.hide();
      };

      $scope.reviewOrder = function () {
         $scope.closeConfirmModal();
        // reviewRequest($stateParams.address_id);
              var order_id  = localStorage.getItem('order_id');
              var paymentUrl = eTakeAwayService.getPaymentUrl(order_id);
              $scope.pageOpened = true;
              $scope.waitingForConfirm = true;
              $ionicNavBarDelegate.showBackButton(false);
              if(localStorage.getItem('payment_method')=='cod'){
                  $ionicLoading.show();
                  openPaymentPage(paymentUrl,true);
              }
              else {
                  openPaymentPage(paymentUrl,false);
              }
      };

      function reviewRequest(address_id) {

        var shippingMethod = $scope.selectedShippingMethod;
        var paymentMethod = $scope.paymentRadio.method;

        if($scope.cb1.selected == "1") {
          $scope.selectedTime.timestamp = "ASAP"
        }

        var requestPacket = {
          customer_id: localStorage.getItem('customer_id'),
          address_id: address_id,
          shipping_method: shippingMethod,
          payment_method: paymentMethod,
          order_requested_time: $scope.selectedTime.timestamp,
          comment: $scope.comment.text
        };
        var voucher = eTakeAwayService.getVoucher();
        if (voucher) {
          requestPacket.voucher = voucher;
        }
        var coupon = eTakeAwayService.getCoupon();
        if (coupon) {
          requestPacket.coupon = coupon;
        }
        var reward = eTakeAwayService.getReward();
        if (reward) {
          requestPacket.reward = reward;
        }
        
        eTakeAwayService.reviewOrder(requestPacket)
          .then(function (res) {
            eTakeAwayService.setReviewOrderPacket(res);
            if (res.order_id) {
              localStorage.setItem('order_id', res.order_id);
              localStorage.setItem('payment_method', res.payment_code);
//              console.log(res);
              $rootScope.cartTotal = '£' + res.total.toFixed(2);
             // console.log(localStorage.getItem('order_id'));
              
              $scope.modal.show();
              
              
            }
            else {
              console.log(res);
            }
          })
      }

      function openPaymentPage(url,hidden) {
        var options = {
          location: 'no',
          clearcache: 'yes',
          toolbar: 'yes'
        };
        if (hidden) {
            options.hidden = 'yes';
        }
        
        $cordovaInAppBrowser.open(url, '_blank', options);
      }

      function confirmOrder() {
        var data = {
          customer_id: localStorage.getItem('customer_id'),
          order_id: localStorage.getItem('order_id')
        };
        eTakeAwayService.confirmOrder(data)
          .then(function (res) {
            if (!res.error) {
              eTakeAwayService.setConfirmationPacket(res);
              $rootScope.cartSize = 0;
              $rootScope.cartTotal = '£0.00';
              $scope.paymentRadio.method = "";
              $scope.comment = {};
              $scope.selectedTime = {};
              $state.go('app.confirmOrder');
            }
            else {
              console.log(res.error);
            }
          }, function (err) {
            console.log(err);
          })
      }

      $rootScope.$on('$cordovaInAppBrowser:loadstart', function (e, event) {
        if (event.url.split('/').pop() == 'success')
        {
          closeFromSuccess = true;
          if($cordovaInAppBrowser) {
            $cordovaInAppBrowser.close();
            $scope.pageOpened = false;
          }
           $scope.waitingForConfirm = false;
           $ionicNavBarDelegate.showBackButton(true);
          confirmOrder();

        }
        else if (event.url.split('/').pop() == 'checkoutetm' || event.url.split('/').pop() == 'checkout' || event.url.split('/').pop() == 'cart') {
          $cordovaInAppBrowser.close();
          $scope.pageOpened = false;
          closeFromSuccess = false;
          $scope.waitingForConfirm = false;
          $ionicNavBarDelegate.showBackButton(true);
          var alertPopup = $ionicPopup.alert({
              title: "Warning!",
              template: '<p>Payment failed!No Funds have been process. Please try again</p>',
              okType: 'button-assertive'
            });
        }
      });
      /*
      $rootScope.$on('$cordovaInAppBrowser:exit', function (e, event) {

          if(!closeFromSuccess && $scope.pageOpened) {
            $scope.pageOpened = false;
            var alertPopup = $ionicPopup.alert({
              title: "Warning!",
              template: '<p>Payment failed!No Funds have been process. Please try again</p>',
              okType: 'button-assertive'
            });
          }
          closeFromSuccess = false;
      });
      */

      $rootScope.$on('$cordovaInAppBrowser:exit', function (e, event) {

          if($scope.waitingForConfirm) {
             // Check Order completed or Not
            
            $ionicLoading.show();
//            customer_id =  localStorage.getItem('customer_id');
            order_id =  localStorage.getItem('order_id');
            eTakeAwayService.checkOrderPaid(order_id)
              .then(function (details) {
//                  $scope.temp  = details; 
                  $ionicLoading.hide();
                  $ionicNavBarDelegate.showBackButton(true);
                  $scope.waitingForConfirm = false;
  
                  if(details.success ) {
                      // Order completed
                      confirmOrder();
                  }
                  else {
//                       alert('cart');
//                      $state.go('app.cartDetails');
                        var alertPopup = $ionicPopup.alert({
                        title: "Warning!",
                        template: '<p>Payment failed!No Funds have been process. Please try again</p>',
                        okType: 'button-assertive'
                      });
                  }
                   
              }) ;  

          }
//          else {
//               alert('exit : un');
//          }
          
      });

    })

    .controller('ConfirmOrder', function ($scope, $state, eTakeAwayService, storeInfo, $ionicLoading) {
      $ionicLoading.hide();
      $scope.storeInfo = storeInfo;
      $scope.storeInfo.telephone = $scope.storeInfo.telephone.replace(/[\s]/g, '');
      $scope.makeCall = function(){
        window.open('tel:'+$scope.storeInfo.telephone, '_system');
      };
      $scope.reviewOrderPacket = eTakeAwayService.getReviewOrderPacket();
      $scope.orderInfo = eTakeAwayService.getConfirmationPacket();
      if ($scope.orderInfo.total) {
        $scope.orderInfo.total = parseFloat($scope.orderInfo.total);
        $scope.orderInfo.total = $scope.orderInfo.total.toFixed(2);
        $scope.orderInfo.total = '£' + $scope.orderInfo.total;
      }
      $scope.orderInfo.subTotal = eTakeAwayService.getSubTotal();
      $scope.orderInfo.delivery = eTakeAwayService.getDeliveryCharges();

      $scope.backToHome = function () {
        $state.go('app.main');
      }

    })

    .controller('RecentOrdersCtrl', function ($scope, $state, eTakeAwayService, recentOrders, $ionicModal, $ionicLoading, $location) {
      $scope.recentOrders = recentOrders.orders;
      $ionicModal.fromTemplateUrl('templates/orderDetailsModal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        })
        .then(function (modal) {
          $scope.detailsModal = modal;
        }, function (err) {
          console.log(err)
        });

      $scope.openOrderDetailsModal = function (orderId) {
        $ionicLoading.show();
        eTakeAwayService.getOrderDetails(orderId)
          .then(function (details) {
            $scope.details = details;
            $scope.orderId = orderId;
            $scope.detailsModal.show();
          })
      };

      $scope.closeOrderDetailsModal = function () {
        $scope.detailsModal.hide();
      };

      $scope.customBack = function () {
        $state.go('app.accountDetail');
      }

      $scope.reOrder = function (orderId) {
        $location.path('app/reorder/' + orderId)
      }
    })

    .controller('ReOrderCtrl', function ($scope, $state, $stateParams, eTakeAwayService, $ionicLoading, addresses, customer, orderDetails, cart) {
      $scope.customBack = function () {
        $state.go('app.recentOrders');
      }
      $scope.details = orderDetails;

      var orderId = $stateParams.id;
      $scope.orderId = $stateParams.id;
      var customer_id = localStorage.getItem('customer_id');
      $scope.confirmOrder = function () {
        eTakeAwayService.reOrder(orderId, customer_id, customer.address_id)
          .then(function (data) {
            $state.go('app.cartDetails');
          }, function (err) {
            console.error(err)
          });
      }

    })

    .controller('AccountDetail', function ($scope, $location, $ionicLoading, $state, customer, $rootScope, recentOrders, $ionicModal, eTakeAwayService, cart) {
      $scope.customer = customer;
      $scope.cart = cart;
      $scope.customBack = function () {
        $state.go('app.main');
      };

      $scope.reOrder = function (orderID) {
        $location.path('app/reorder/' + orderID);
      };

      $scope.doLogout = function () {
        localStorage.removeItem('customer_id');
        localStorage.removeItem('address_id');
        $rootScope.customer_id = null;
        $rootScope.cartSize = 0;
        $rootScope.cartTotal = '£0.00';
        $state.go('app.welcome', {referrer: 'logout'});
      };

      $scope.recentOrders = recentOrders;

      $ionicModal.fromTemplateUrl('templates/orderHistoryModal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        })
        .then(function (modal) {
          $scope.historyModal = modal;
        }, function (err) {
          console.log(err)
        });

      $scope.openOrderHistoryModal = function () {
        $state.go('app.recentOrders');
      };

      $scope.closeOrderHistoryModal = function () {
        $scope.historyModal.hide();
      };

      $ionicModal.fromTemplateUrl('templates/orderDetailsModal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        })
        .then(function (modal) {
          $scope.detailsModal = modal;
        }, function (err) {
          console.log(err)
        });

      $scope.openOrderDetailsModal = function (orderId) {
        $ionicLoading.show();
        eTakeAwayService.getOrderDetails(orderId, $rootScope.customer_id)
          .then(function (details) {
            $scope.details = details;
            $scope.orderId = orderId;
            $scope.detailsModal.show();
          })
      };

      $scope.closeOrderDetailsModal = function () {
        $scope.detailsModal.hide();
      };
    })

    .controller('FeedbackCtrl', function ($scope, $state, $rootScope, eTakeAwayService) {
      $scope.stars = {
        taste: 0,
        presentation: 0,
        employee: 0,
        speed: 0,
        price: 0
      }
      $scope.max = 5;
      $scope.userData = {};
      $scope.average = {value: 0.0};

      $scope.updateRating = function () {
        var avg = 0.0;
        var total = 0;
        var count = 0;
        for (var key in $scope.stars) {
          total += $scope.stars[key];
          count++;
        }
        avg = total / count;
        $scope.average.value = avg.toFixed(0);
      }

      $scope.submitFeedback = function () {
        var feedbackPacket = {};
        if ($rootScope.customer_id) {
          feedbackPacket.customer_id = $rootScope.customer_id
        }
        else {
          feedbackPacket.name = $scope.userData.name,
            feedbackPacket.email = $scope.userData.email
        }
        feedbackPacket.feedback = $scope.userData.message;
        feedbackPacket.stars = $scope.average.value;
        eTakeAwayService.submitFeedback(feedbackPacket)
          .then(function (res) {
            $scope.stars = {
              taste: 0,
              presentation: 0,
              employee: 0,
              speed: 0,
              price: 0
            }
            $scope.average = {value: 0.0};
            $scope.userData = {};
            $state.go('app.main');
          }, function (err) {
            console.log(err);
          })
      }

      $scope.customBack = function () {
        $state.go('app.main');
      }
    })

    .controller('WelcomeCtrl', function ($scope, $state, $stateParams, $ionicHistory) {

      if ($stateParams.referrer == 'logout') {
        $ionicHistory.clearHistory();
      }

      $scope.login = function () {
//        console.log('welcome', $stateParams.referrer);
        $state.go('app.login', {referrer: $stateParams.referrer});
      }

      $scope.signup = function () {
        $state.go('app.signup', {referrer: $stateParams.referrer});
      }


    })

    .controller('InformationCtrl', function ($scope, $state, eTakeAwayService, $cordovaInAppBrowser) {

      // console.log("in information controller");
      eTakeAwayService.getStoreInfo().then(function (res) {
        //console.log(res.store_times);
        $scope.weekday_timings = res.store_times;
//        var temp_timings = {};
//        var weekday_timings = [];
//        temp_timings = res.store_times;
//
//        for (var item in temp_timings) {
//          var temp_obj = {};
//          temp_obj.day = item;
//          temp_obj.start = temp_timings[item][0].start;
//          temp_obj.end = temp_timings[item][0].end;
//
//          weekday_timings.push(temp_obj);
//        }
//     //   console.log(weekday_timings);
//        $scope.weekday_timings = weekday_timings;

        $scope.map = {
          center: [res.coordinates.latitude, res.coordinates.longitude]
        };

        $scope.telephone = res.telephone;
        $scope.storeInfo = res;
      }, function (err) {
        console.log(err);
      });

      var options = {
        location: 'yes',
        clearcache: 'yes',
        toolbar: 'no'
      };

      $scope.openWebsite = function (url) {
        $cordovaInAppBrowser.open(url, '_blank', options);
      }

      $scope.customBack = function () {
        $state.go('app.main');
      }

    })

    .controller('ForgetPassword', function ($scope, $state, eTakeAwayService) {
      $scope.disableEmail = false;
      $scope.disableButton = false;
      $scope.message = "";
      $scope.resetData = {};

      $scope.doResetPassword = function () {
        $scope.disableEmail = true;
        $scope.disableButton = true;
        eTakeAwayService.forgottenPassword($scope.resetData)
          .then(function (res) {
            if (res.error_warning == "") {
              $scope.message = 'Your password has been changed successfully. Your new password has been emailed to your given email address.';
            }
            else {
              $scope.message = res.error_warning;
              $scope.disableEmail = false;
              $scope.disableButton = false;
            }
          }, function (err) {
            console.log(err);
          })
      }
      $scope.customBack = function () {
        $state.go('app.login');
      }
    })

    .controller('ChangePassword', function ($scope, $state, $rootScope, eTakeAwayService) {
      $scope.message = "";
      $scope.passwordData = {};

      $scope.doChangePassword = function () {
        eTakeAwayService.login({email: $scope.passwordData.email, password: $scope.passwordData.currentPassword})
          .then(function (res) {
            if (res.error) {
              $scope.alert = true;
              $scope.message = res.error;
            }
            else {
              $scope.passwordData.customer_id = $rootScope.customer_id;
              // delete $scope.passwordData.currentPassword;
              // delete $scope.passwordData.Password2;
              eTakeAwayService.changePassword({password: $scope.passwordData.password})
                .then(function (res) {
                  console.log(res);
                  $scope.message = 'Your password has been changed successfully.';
                  $scope.alert = true;
                }, function (err) {
                  console.log(err);
                })
            }
          }, function (err) {
            console.log(err);
          })
      }
      $scope.customBack = function () {
        $state.go('app.accountDetail');
      }
    })

    .controller('EditAccountInfoCtrl', function ($scope, $state, customer, $ionicLoading, eTakeAwayService) {
//      console.log("EditAccountInfoCtrl Ctrl");
      $ionicLoading.hide();
      $scope.alert = false;
      $scope.message = "";
      $scope.userData = {
        firstname: customer.firstname,
        lastname: customer.lastname,
        email: customer.email,
        telephone: customer.telephone
      }
      $scope.update = function () {
        eTakeAwayService.changeCustomerDetails($scope.userData)
          .then(function (res) {
//            console.log(res);
            if (res.success) {
              $state.go('app.accountDetail');
            }
            else if (res.error) {
              $scope.alert = true;
              $scope.message = res.error;
            }

          }, function (err) {
            $scope.alert = true;
            $scope.message = err.error;
            console.log(err);
          })
      }
      $scope.customBack = function () {
        $state.go('app.accountDetail');
      }

    })

    .controller('AddressBookCtrl', function ($scope, $state, $rootScope, addresses, eTakeAwayService) {
//      console.log(addresses);
      $scope.addresses = [];
      for (var key in addresses) {
        address=addresses[key]
        addrss=address.address_1.split('\n');
        address.houseno = addrss[0];
        address.address_1 = addrss[1];
        address.telephone = addrss[2];
        $scope.addresses[$scope.addresses.length]=address;
      }
//      console.log(addrss);

      $scope.editAddress = function (address) {
//          console.log(address.telephone); 
        $state.go('app.editAddress', {
          addressId: address.address_id,
          firstname: address.firstname,
          lastname: address.lastname,
          address: address.address_1,
          postcode: address.postcode,
          houseno: address.houseno,
          telephone: address.telephone
        })
      }

      $scope.customBack = function () {
        $state.go('app.accountDetail');
      }
    })

    .controller('EditAddressCtrl', function ($scope, $state, $stateParams, $rootScope, eTakeAwayService) {
      $scope.addressData = {};
//console.log($stateParams.telephone);
      $scope.addressData.firstname = $stateParams.firstname;
      $scope.addressData.lastname = $stateParams.lastname;
      $scope.addressData.address = $stateParams.address;
      $scope.addressData.postcode = $stateParams.postcode;
      $scope.addressData.houseno = $stateParams.houseno;
      $scope.addressData.telephone = $stateParams.telephone;
      $scope.message = "";

      $scope.doEditAddress = function () {
//         console.log($scope.addressData.telephone);
        var addressPacket = {
          customer_id: $rootScope.customer_id,
          address_id: $stateParams.addressId,
          firstname: $scope.addressData.firstname,
          lastname: $scope.addressData.lastname,
          address: $scope.addressData.houseno + '\n' + $scope.addressData.address + '\n' + $scope.addressData.telephone,
          postcode: $scope.addressData.postcode,
          houseno: $scope.addressData.houseno,
          telephone: $scope.addressData.telephone
          
        }

        eTakeAwayService.changeAddress(addressPacket)
          .then(function (res) {
            if (res.success == 'ok') {
              $scope.message = 'Your address has been updated.';
            }
            else {
              $scope.message = 'Something went wrong on the server.';
            }
          }, function (err) {
            console.log(err);
          })
      }

      $scope.customBack = function () {
        $state.go('app.addressBook');
      }
    })

    .controller('AddAddressCtrl', function ($scope, $state, $rootScope, eTakeAwayService) {
      $scope.newAddress = {};
      $scope.message = "";
      $scope.disableButton = false;

      $scope.doAddAddress = function () {
        var addressData = {
          customer_id: $rootScope.customer_id,
          firstname: $scope.newAddress.firstname,
          lastname: $scope.newAddress.lastname,
          address: $scope.newAddress.houseno + '\n' + $scope.newAddress.address + '\n' + $scope.newAddress.telephone,
          postcode: $scope.newAddress.postcode,
          houseno: $scope.newAddress.houseno,
          telephone: $scope.newAddress.telephone
        }

        eTakeAwayService.addAddress(addressData)
          .then(function (res) {
            if (res.error) {
              $scope.message = res.error;
            }
            else {
              $scope.disableButton = true;
              $scope.message = 'Your address has been added.';
            }
          }, function (err) {
            console.log(err);
          });
      }

      $scope.customBack = function () {
        $state.go('app.addressBook');
      }
    })
}());
