(function () {
	'use strict';

	angular
		.module('services')
		.factory('dbService', dbService);

	dbService.$inject = ['$cordovaSQLite', '$q', '$ionicLoading', '$timeout', 'eTakeAwayService'];

	/* @ngInject */
	function dbService($cordovaSQLite, $q, $ionicLoading, $timeout, eTakeAwayService) {
		var db;
		function prepareDatabase() {
			var deferred = $q.defer();
			var progress = 0;
			var time = 99000;
			for (var i = 0; i <= time / 1000; i++) {
				$timeout(function() {
					deferred.notify(progress++);
				}, i * 750);
			}

			if (window.cordova) {
				db = $cordovaSQLite.openDB({ name: "etakeaway.db",location: 'default'});
			}
			else {
				db = window.openDatabase("etakeaway.db", '1', 'my', 1024 * 1024 * 100); // browser
			}

			// var statement = "CREATE TABLE IF NOT EXISTS Category (category_id integer primary key, name text, image text, parent_id integer, parent_category integer,description text)";
			var statement = "CREATE TABLE IF NOT EXISTS settings (setkey TEXT, setvalue TEXT)";

			$ionicLoading.show();
			$cordovaSQLite.execute(db, statement)
			.then( function() {
                                var statement = "CREATE TABLE IF NOT EXISTS categorytoproducts (category_id INTEGER ,product_id INTEGER)";
     
				$cordovaSQLite.execute(db, statement)
                                .then( function() {
                                    statement = "CREATE TABLE IF NOT EXISTS products (product_id INTEGER PRIMARY KEY,product TEXT)";

                                    $cordovaSQLite.execute(db, statement)
				.then(function(res) {
					syncDatabase().then( function (res) {
						if (res.updated) {
							var startPage = 0;
							var endPage = 31;
							var promises = [];
							while (startPage <= endPage) {
								var promise = eTakeAwayService.getProducts(startPage)
								startPage++;
								promises.push(promise);
								var count = 0;
							}
							var productPromises = [];
							$q.all(promises)
							.then(function (data) {
								data.forEach(function (res) {
									var res_arr = Object.keys(res).map(function (key) {
										return res[key]
									});
									res_arr.forEach(function (product) {
                                                                                   //  console.log(product) ;
										productPromises.push(updateProduct(product));
									});
									count++;
									if (count == data.length) {
										$q.all(productPromises).then(function (data) {
                                                                                            getMenu().then(function (menu) {
												$ionicLoading.hide();
												deferred.notify('100');
												deferred.resolve(menu);
											}, function (err) {
												console.log(err);
												deferred.reject(err);
											})
										})
									}
								});
							}, function (err) {
								deferred.reject(err);
								console.error("some error occured while resolving loop of promises");
							});
						}
						else {
                                                            getMenu().then(function (menu) {
								$ionicLoading.hide();
								deferred.notify('100');
								deferred.resolve(menu);
							}, function (err) {
								console.log(err);
								deferred.reject(err);
							})
						}
					});
				}), function (err) {
					deferred.reject(err);
				}
                                
                                }), function (err) {
					deferred.reject(err);
				}
			});
			return deferred.promise;
		}

		function syncDatabase() {
			var deferred = $q.defer();
			var lastModified = localStorage.getItem('lastModified');
			eTakeAwayService.getLastModifiedDate()
			.then(function (res) {
				var new_lastModified = res.last_modified;
				if (lastModified && lastModified == new_lastModified) {
					var data = {updated: false};
					deferred.resolve(data);
				}
				else {
					// Clear DB
                                        $cordovaSQLite.execute(db, "DELETE FROM settings",[]);
                                        $cordovaSQLite.execute(db, "DELETE FROM categorytoproducts",[]);
                                        $cordovaSQLite.execute(db, "DELETE FROM products",[]);
					eTakeAwayService.getCategories()
					.then( function (data) {
						var categoriesData = data;
						updateCategories(data.menus).then(function() {
							localStorage.setItem('lastModified', new_lastModified);
							var data = {updated: true};
							deferred.resolve(data);
						}, function (err) {
							deferred.reject(err)
						})
					}, function (err) {
						deferred.reject(err)
						console.log(err);
					})
				}
			}, function (err) {
				console.log(err);
			});
			return deferred.promise;
		}

		function updateCategories(categories) {
			var deferred = $q.defer();
			var count = 0;
			if (categories && categories.length) {
                                insertCategory(categories);
                                var menus = cat_subs(categories);
                                menus.forEach( function (category) {
                                    category.products.forEach( function (product_id) {
                                        insertProductIds(product_id, category.category_id);
                                    });
					count++;
					if(count == menus.length) {
						deferred.resolve();
					}
				});
//				categories.forEach( function (category) {
//					if(category.categories)
//					{
//						category.categories.forEach( function (cat) {
//							//insertCategory(cat, category.category_id);
//                                                        category.products.forEach( function (product) {
//                                                            console.log(product + ' -- ' + category.category_id);
//
//                                                             insertProductIds(product, category.category_id);
//                                                        });
//						});
//					}
//					count++;
//					if(count == categories.length) {
//						deferred.resolve();
//					}
//				});
			}
			return deferred.promise;
		}
                function cat_subs(menus) {
                    var cats = [];
                    for (var i in menus) {
                        var category = menus[i];
                        cats.push({category_id: category['category_id'], products: category['products']});
                        if (category['categories'] && category['categories'].length > 0) {
                            cats = cats.concat(cat_subs(category['categories']));
                        }
                    }
                    return cats;
                }
		function insertCategory(categories) {
			var query = "INSERT OR REPLACE INTO settings(setkey,setvalue) VALUES (?,?)";
			$cordovaSQLite.execute(db, query, ['menus', JSON.stringify(categories)])
            .then(function(res){
                console.log(res);
            }
            ,function(err){
                console.log(err);
            });


		}

		function insertProductIds(product_id, category_id) {
                     //  console.log(product_id  + ' -- ' + category_id);
			var query = "INSERT OR REPLACE INTO categorytoproducts (category_id , product_id) VALUES (?,?)";
			$cordovaSQLite.execute(db, query, [ category_id,product_id]);
		}

		function updateProduct(product_org) {
			var iproduct = JSON.parse(product_org);
			//var bundled_items = JSON.stringify(product.bundled_items);
			//var product_options = JSON.stringify(product.option);
			var query = "INSERT OR REPLACE INTO Products (product_id,product) VALUES (?,?)";
                       
			$cordovaSQLite.execute(db, query, [ iproduct.product_id, JSON.stringify(iproduct)])
			.then( function (res) {
				console.log('product ' + iproduct.product_id + ' updated.');
			}, function (err) {
				console.log('product not updated.');
				console.log(err);
			})
		}

		function getMenu() {
                        
			var deferred = $q.defer();
			var query = "SELECT setvalue FROM  settings WHERE setkey='menus'";
			$cordovaSQLite.execute(db, query, [])
			.then( function (res) {
				deferred.resolve(JSON.parse(res.rows.item(0).setvalue));
			}, function (err) {
				console.log(err);
				deferred.reject(err);
			});
			return deferred.promise;
		}

                
		function getProducts(category_id) {
			$ionicLoading.show();
			var deferred = $q.defer();
			var query = "SELECT * FROM Products JOIN categorytoproducts ON (categorytoproducts.product_id = Products.product_id ) WHERE categorytoproducts.category_id = ?";
			$cordovaSQLite.execute(db, query, [category_id])
			.then( function (res) {
				$ionicLoading.hide();
				deferred.resolve(res);
			}, function (err) {
				$ionicLoading.hide();
				deferred.reject(err);
			});
			return deferred.promise;
		}

		function getProduct(product_id) {

			$ionicLoading.show();
			var deferred = $q.defer();
			var query = "SELECT * FROM Products WHERE product_id = ?";
			$cordovaSQLite.execute(db, query, [product_id])
			.then( function (res) {
				$ionicLoading.hide();
				deferred.resolve(JSON.parse(res.rows.item(0).product));
			}, function (err) {
				$ionicLoading.hide();
				deferred.reject(err);
			});
			return deferred.promise;
		}

    function getCategory(category_id){
      var catId = parseInt(category_id);
      $ionicLoading.show();
      var deferred = $q.defer();
      var query = "SELECT * FROM Category WHERE category_id = ?";
      $cordovaSQLite.execute(db, query, [catId])
        .then( function (res) {
          $ionicLoading.hide();
          deferred.resolve(res);
        }, function (err) {
          $ionicLoading.hide();
          deferred.reject(err);
        });
      return deferred.promise;
    }

		return {
			prepareDatabase: prepareDatabase,
			syncDatabase: syncDatabase,
			insertCategory: insertCategory,
			insertProductIds: insertProductIds,
			getMenu: getMenu,
			updateProduct: updateProduct,
			getProducts: getProducts,
			getProduct: getProduct,
      getCategory:getCategory
		};
	}

})();

