( function () {

	angular.module('services')
		.factory('eTakeAwayService', function (requestManager, $q, $ionicLoading, $rootScope) {
			var urls = {
				baseURL: 'http://www.muktabaltiyeovil.co.uk/mobileapi2/',
				menus: 'getMenus',
				register: 'register',
				lastModified: 'getLastModified',
				getProduct: 'getProduct',
				getProducts: 'getProducts',
				login:'login',
				getCustomerDetails: 'getcustomerdetails',
        getOrderDetails:'getorder',
        getRecentOrder:'getcustomerorders',
        reOrder:'reorder',
				forgetPassword: 'forgottenPassword',
				changePassword: 'changepassword',
				cartdetails: 'cartdetails',
				getStoreInfo: 'getstoreinfo',
				getStoreOpened:'getstoreopened',
				getOffers:'getOffers',
				getCustomerAddresses: 'getcustomeraddresses',
				addAddress: 'addadress',
				changeCustomerDetails : 'changecustomerdetails',
				reviewOrder: 'revieworder',
				paymentUrl: 'orderpaymenturl&order_id=',
				confirmOrder: 'confirmorder',
				feedback: 'submitFeedback',
				changeAddress: 'changeaddress',
				searchPostcode: 'searchpostcode',
                                checkorderpaid: 'checkorderpaid',

			}

			var shipping_methodes = [];
			var payment_methodes = [];
			var selectedShippingMethod = "";
			var selectedPaymentMethod = "";
			var voucher = null;
			var coupon = null;
			var reward = null;
			var localCart = [];
			var subTotal = '£0.00';
			var orderConfirmationPacket = {};
			var deliveryCharges = '£0.00';
                        var reviewOrderPacket = {};
                        
                        //
            var min = 1000 * 60;
            var hr  = min * 60 ;
            var httpcache = {
                getStoreInfo: {
                    time:null,
                    data:null,
                    intervel : (hr * 2 ) 
                },
                getStoreOpened: {
                    time:null,
                    data:null,
                    intervel : (min * 5 ) 
                },
                getOffers: {
                    time:null,
                    data:null,
                    intervel : (hr * 2 ) 
                },
                getLastModifiedDate : {
                    time:null,
                    data:null,
                    intervel : (hr * 1 ) 
                }
            };
            
			function login (data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.login;
				requestManager.post(url, data)
					.then(function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function getCategories() {
				var url = urls.baseURL + urls.menus;
				return requestManager.get(url, {});
			}

			function getLastModifiedDate() {
				var deferred = $q.defer();
                if( httpcache.getLastModifiedDate.time != null  && new Date() - httpcache.getLastModifiedDate.time < httpcache.getLastModifiedDate.intervel ) {
                    deferred.resolve(httpcache.getLastModifiedDate.data); 
                }
                else {
				var url = urls.baseURL + urls.lastModified;
				requestManager.get(url, {})
                        .then(function (res) {
                            httpcache.getLastModifiedDate.time = new Date();
                            httpcache.getLastModifiedDate.data = res;
						deferred.resolve(res);
					}, function (err) {
						deferred.reject(err);
					});
                }
				return deferred.promise;
			}

			function register (data) {
				var deferred = $q.defer();
				var url = urls.baseURL + urls.register;
				requestManager.post(url, data)
					.then( function (res) {
						deferred.resolve(res);
					}, function (err) {
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function getProduct(id) {
				var url = urls.baseURL + urls.getProduct;
				var data = {product_id: id};
				requestManager.post(url, data)
					.then( function (res) {
						return res;
					}, function (err) {
						return err;
					});
			}

			function getProducts(page) {
				var deferred = $q.defer();
				var url = urls.baseURL + urls.getProducts;
				var data = {page: page};
				requestManager.post(url, data)
					.then( function (res) {
						deferred.resolve(res);
					}, function (err) {
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function getCustomerDetails(customer_id) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.getCustomerDetails;
				var data = {customer_id: customer_id};
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

            function getRecentOrders(customer_id){
                $ionicLoading.show();
                var deferred = $q.defer();
                var url = urls.baseURL + urls.getRecentOrder;
                var data = {customer_id: customer_id};
                requestManager.post(url, data)
                    .then( function (res) {
                        $ionicLoading.hide();
                        deferred.resolve(res);
                    }, function (err) {
                        $ionicLoading.hide();
                        deferred.reject(err);
                    });
                return deferred.promise;
            }

            function getOrderDetails(orderId,customerId){
                $ionicLoading.show();
                var deferred = $q.defer();
                var url = urls.baseURL + urls.getOrderDetails;
                var data = {order_id: orderId,customer_id: customerId};
                requestManager.post(url, data)
                    .then( function (res) {
                        $ionicLoading.hide();
                        deferred.resolve(res);
                    }, function (err) {
                        $ionicLoading.hide();
                        deferred.reject(err);
                    });
                return deferred.promise;
            }

            function reOrder(orderId,customerId,addressId){
                $ionicLoading.show();
                var deferred = $q.defer();
                var url = urls.baseURL + urls.reOrder;
                var data = {order_id: orderId,customer_id:customerId,address_id:addressId};
                requestManager.post(url, data)
                    .then( function (res) {
                        $ionicLoading.hide();
                        deferred.resolve(res);
                    }, function (err) {
                        $ionicLoading.hide();
                        deferred.reject(err);
                    });
                return deferred.promise;
            }

			function forgottenPassword(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.forgetPassword;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function changePassword(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.changePassword;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function cartDetails(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.cartdetails;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						var size = 0;
						for (var property in res.products) {
							size++;
						}
						$rootScope.cartSize = size;
						if (res.totals && res.totals.length) {
							res.totals.forEach(function (item) {
								if (item.code == 'total') {
									if (item.value) {
										var total = item.value.toFixed(2);
										$rootScope.cartTotal = '£' + total;
									}
									else {
										$rootScope.cartTotal = '£0.00';
									}
								}
								else if (item.code == 'sub_total') {
									if (item.value) {
										subTotal = item.value.toFixed(2);
										subTotal = '£' + subTotal;
									}
									else {
										subTotal = '£0.00';
									}
								}
							})
						}
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function getStoreInfo() {
				var deferred = $q.defer();
                if( httpcache.getStoreInfo.time != null  && new Date() - httpcache.getStoreInfo.time < httpcache.getStoreInfo.intervel ) {
                    deferred.resolve(httpcache.getStoreInfo.data); 
                }
                else {
				var url = urls.baseURL + urls.getStoreInfo;
				requestManager.post(url, {})
                            .then(function (res) {
                                httpcache.getStoreInfo.time = new Date();
                                httpcache.getStoreInfo.data = res;
						deferred.resolve(res);
					}, function (err) {
						deferred.reject(err);
					});
                }
				return deferred.promise;
			}

			function getStoreOpened() {
				var deferred = $q.defer();
                if( httpcache.getStoreOpened.time != null  && new Date() - httpcache.getStoreOpened.time < httpcache.getStoreOpened.intervel ) {
                    deferred.resolve(httpcache.getStoreOpened.data); 
                }
                else {
				var url = urls.baseURL + urls.getStoreOpened;
				requestManager.post(url, {})
                        .then(function (res) {
                            httpcache.getStoreOpened.time = new Date();
                            httpcache.getStoreOpened.data = res;
						deferred.resolve(res);
					}, function (err) {
						deferred.reject(err);
					});
                    }
				return deferred.promise;
			}

			function getOffers() {
				var deferred = $q.defer();
                if( httpcache.getOffers.time != null  && new Date() - httpcache.getOffers.time < httpcache.getOffers.intervel ) {
                    deferred.resolve(httpcache.getOffers.data); 
                }
                else {
				var url = urls.baseURL + urls.getOffers;
				requestManager.post(url, {})
                            .then(function (res) {
                                httpcache.getOffers.time = new Date();
                                httpcache.getOffers.data = res;
						deferred.resolve(res);
					}, function (err) {
						deferred.reject(err);
					});
                }
				return deferred.promise;
			}

			function getCustomerAddresses(customer_id) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.getCustomerAddresses;
				var data = {customer_id: customer_id};
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function changeCustomerDetails(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.changeCustomerDetails;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function reviewOrder(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.reviewOrder;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function confirmOrder(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.confirmOrder;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function submitFeedback(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.feedback;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function addAddress(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.addAddress;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function changeAddress(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.changeAddress;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}

			function getPaymentUrl (order_id) {
				return urls.baseURL + urls.paymentUrl + order_id;
			}

			function setShippingMethods (methods) {
				shipping_methodes = methods;
			}

			function getShippingMethods () {
				return shipping_methodes;
			}

			function setPaymentMethods (methods) {
				payment_methodes = methods;
			}

			function getPaymentMethods () {
				return payment_methodes;
			}

			function setSelectedShippingMethod (methodName) {
				selectedShippingMethod = methodName;
			}

			function getSelectedShippingMethod () {
				return selectedShippingMethod;
			}

			function setSelectedPaymentMethod(methodName) {
				selectedPaymentMethod = methodName;
			}

			function getSelectedPaymentMethod () {
				return selectedPaymentMethod;
			}

            function setReviewOrderPacket (packet)
            {
                reviewOrderPacket = packet;
            }

			function addToLocalCart(product) {
				localCart.push(product);
				$rootScope.cartSize++;
				var total = $rootScope.cartTotal.split('£');
				total = parseFloat(total[1]);
				var price = product.total.split('£');
				price = parseFloat(price[1]);
				total += price;
				total = total.toFixed(2);
				$rootScope.cartTotal = '£' + total;
			}

			function updateProductLocal(productKey, quantity) {
				if (localCart.length) {
					localCart.forEach(function (item, i) {
						if (item.productKey == productKey) {
							var total = $rootScope.cartTotal.split('£');
							total = parseFloat(total[1]);
							var price = item.price.split('£');
							price = parseFloat(price[1]);
							if (localCart[i].quantity < quantity) {
								total += price;
							}
							else {
								total -= price;
							}
							localCart[i].quantity = quantity;
							total = total.toFixed(2);
							$rootScope.cartTotal = '£' + total;
						}
					})
				}
			}

			function getLocalCart() {
				return localCart;
			}

			function removeFromLocalCart(productKey) {
				if (localCart.length) {
					localCart.forEach(function (item, i) {
						if (item.productKey == productKey) {
							$rootScope.cartSize--;
							var total = $rootScope.cartTotal.split('£');
							total = parseFloat(total[1]);
							var price = item.total.split('£');
							price = parseFloat(price[1]);
							total -= price;
							total = total.toFixed(2);
							$rootScope.cartTotal = '£' + total;
							localCart.splice(i, 1);
						}
					})
				}
			}

			function emptyLocalCart() {
				localCart = [];
			}

			function searchPostcode(data) {
				$ionicLoading.show();
				var deferred = $q.defer();
				var url = urls.baseURL + urls.searchPostcode;
				requestManager.post(url, data)
					.then( function (res) {
						$ionicLoading.hide();
						deferred.resolve(res);
					}, function (err) {
						$ionicLoading.hide();
						deferred.reject(err);
					});
				return deferred.promise;
			}
                        function checkOrderPaid(orderId){
                            $ionicLoading.show();
                            var deferred = $q.defer();
                            var url = urls.baseURL + urls.checkorderpaid;
                            var data = {order_id: orderId};
                            requestManager.post(url, data)
                                .then( function (res) {
                                    $ionicLoading.hide();
                                    deferred.resolve(res);
                                }, function (err) {
                                    $ionicLoading.hide();
                                    deferred.reject(err);
                                });
                            return deferred.promise;
                        }
			function setVoucher(code) {
				voucher = code;
			}

			function getVoucher() {
				return voucher;
			}

			function setCoupon(code) {
				coupon = code;
			}

			function getCoupon() {
				return coupon;
			}

			function setReward(points) {
				reward = points;
			}

			function getReward() {
				return reward;
			}

			function setSubTotal(value) {
				subTotal = value;
			}

			function getSubTotal() {
				return subTotal;
			}

			function setConfirmationPacket(packet) {
				orderConfirmationPacket = packet;
			}

			function getConfirmationPacket() {
				return orderConfirmationPacket;
			}

			function setDeliveryCharges(rate) {
				deliveryCharges = rate;
			}

			function getDeliveryCharges() {
				return deliveryCharges;
			}

            function getReviewOrderPacket ()
            {
                return reviewOrderPacket;
            }

			return {
				getCategories: getCategories,
				getLastModifiedDate: getLastModifiedDate,
				register: register,
				getProduct: getProduct,
				getProducts: getProducts,
				login: login,
				getCustomerDetails: getCustomerDetails,
				forgottenPassword: forgottenPassword,
				changePassword: changePassword,
				cartDetails: cartDetails,
				getStoreInfo: getStoreInfo,
				getStoreOpened: getStoreOpened,
				getOffers: getOffers,
				getCustomerAddresses: getCustomerAddresses,
				addAddress: addAddress,
				changeCustomerDetails: changeCustomerDetails,
				reviewOrder: reviewOrder,
				confirmOrder: confirmOrder,
				getPaymentUrl: getPaymentUrl,
				setShippingMethods: setShippingMethods,
				getShippingMethods: getShippingMethods,
				setPaymentMethods: setPaymentMethods,
				getPaymentMethods: getPaymentMethods,
				setSelectedShippingMethod: setSelectedShippingMethod,
				getSelectedShippingMethod: getSelectedShippingMethod,
				setSelectedPaymentMethod: setSelectedPaymentMethod,
				getSelectedPaymentMethod: getSelectedPaymentMethod,
				addToLocalCart: addToLocalCart,
				updateProductLocal: updateProductLocal,
				getLocalCart: getLocalCart,
				removeFromLocalCart: removeFromLocalCart,
				emptyLocalCart: emptyLocalCart,
				submitFeedback: submitFeedback,
				changeAddress: changeAddress,
				searchPostcode: searchPostcode,
				setVoucher: setVoucher,
				getVoucher: getVoucher,
				setCoupon: setCoupon,
				getCoupon: getCoupon,
				setReward: setReward,
				getReward: getReward,
				setSubTotal: setSubTotal,
				getSubTotal: getSubTotal,
				setConfirmationPacket: setConfirmationPacket,
				getConfirmationPacket: getConfirmationPacket,
				setDeliveryCharges: setDeliveryCharges,
				getDeliveryCharges: getDeliveryCharges,
                getRecentOrders:getRecentOrders,
                getOrderDetails:getOrderDetails,
                checkOrderPaid:checkOrderPaid,
                reOrder:reOrder,
                getReviewOrderPacket:getReviewOrderPacket,
                setReviewOrderPacket:setReviewOrderPacket
			}
		});

}());
